import { type MappingConfigs, TableColumnEnumBase, type TableColumnEnumColumnConfig } from '../enum-base';
import { TableColumnMappingValidator } from './models/table-column-mapping-validator';
import type { ColumnInternalsOptions } from '../base/models/column-internals';
import type { Mapping } from '../../mapping/base';
import type { MappingConfig } from '../enum-base/models/mapping-config';
import { TableColumnMappingWidthMode } from './types';
declare global {
    interface HTMLElementTagNameMap {
        'nimble-table-column-mapping': TableColumnMapping;
    }
}
declare const TableColumnMapping_base: (abstract new (...args: any[]) => {
    groupingDisabled: boolean;
    groupIndex?: number | null;
    groupingDisabledChanged(): void;
    groupIndexChanged(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<[]>>;
}) & (abstract new (...args: any[]) => {
    fractionalWidth?: number | null;
    minPixelWidth?: number | null;
    fractionalWidthChanged(): void;
    minPixelWidthChanged(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<[]>>;
}) & (abstract new (...args: any[]) => {
    sortingDisabled: boolean;
    sortIndex?: number | null;
    sortDirection: import("../../table/types").TableColumnSortDirection;
    sortingDisabledChanged(): void;
    sortDirectionChanged(): void;
    sortIndexChanged(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<[]>>;
}) & ((abstract new () => TableColumnEnumBase<TableColumnEnumColumnConfig, TableColumnMappingValidator>) & {
    compose<T extends import("@ni/fast-foundation").FoundationElementDefinition = import("@ni/fast-foundation").FoundationElementDefinition, K extends import("@ni/fast-element").Constructable<import("@ni/fast-foundation").FoundationElement> = import("@ni/fast-element").Constructable<import("@ni/fast-foundation").FoundationElement>>(this: K, elementDefinition: T): (overrideDefinition?: import("@ni/fast-foundation").OverrideFoundationElementDefinition<T>) => import("@ni/fast-foundation").FoundationElementRegistry<T, K>;
    from<TBase extends {
        new (): HTMLElement;
        prototype: HTMLElement;
    }>(BaseType: TBase): new () => InstanceType<TBase> & import("@ni/fast-element").FASTElement;
    define<TType extends Function>(type: TType, nameOrDef?: string | import("@ni/fast-element").PartialFASTElementDefinition): TType;
});
/**
 * Table column that maps number, boolean, or string values to an icon, a spinner,
 * text, or an icon/spinner with text.
 */
export declare class TableColumnMapping extends TableColumnMapping_base {
    widthMode: TableColumnMappingWidthMode;
    minPixelWidthChanged(): void;
    protected getColumnInternalsOptions(): ColumnInternalsOptions<TableColumnMappingValidator>;
    protected createColumnConfig(mappingConfigs: MappingConfigs): TableColumnEnumColumnConfig;
    protected createMappingConfig(mapping: Mapping<unknown>): MappingConfig;
    private widthModeChanged;
    private getConfiguredMinPixelWidth;
}
export declare const tableColumnMappingTag = "nimble-table-column-mapping";
export {};
